// =========================================================================================================
//  Urban Patrol Script  by Monsada
//  Version: 5.0.4
//  Author: Monsada (smirall@hotmail.com)
//		http://www.simulacion-esp.com/
//		Comunidad Hispana de Simulacin
// =========================================================================================================
//  Basado en el script Urban Patrol Script  de Kronzky  
//  Version: 2.0.3 
//  Author: Kronzky (www.kronzky.info / kronzky@gmail.com)
// ---------------------------------------------------------------------------------------------------------

//Adding eventhandlers
"KRON_UPS_EAST_SURRENDED" addPublicVariableEventHandler { if (_this select 1) then { nul=[east] execvm "upsmon\surrended.sqf";};};
"KRON_UPS_WEST_SURRENDED" addPublicVariableEventHandler { if (_this select 1) then { nul=[west] execvm "upsmon\surrended.sqf";};};
"KRON_UPS_GUER_SURRENDED" addPublicVariableEventHandler { if (_this select 1) then { nul=[resistance] execvm "upsmon\surrended.sqf";};};

if (!isServer) exitWith {};

//Enable debug, in debug could see a mark positioning de leader and another mark of the destinity of movement, very useful for editing mision
//Habilita el estado de debug, el cual permite ver la posicin de los grupos as como a donde se dirigen,
//en modo local tambien muestra mensajes del comportamiento de la IA
KRON_UPS_Debug = 0;

//Time that lider wait until doing another movement, this time reduced dinamically under fire, and on new targets
//Tiempo que tarda en calcular un nuevo movimiento (en combate), no le des poco tiempo o no har ms que moverse
KRON_UPS_react = 60;

//Min time to wait for doing another reaction
KRON_UPS_minreact = 30;

//Max waiting is the maximum time patrol groups will wait when arrived to target for doing another target.
//Parmetro para patrullas (MOVE) Tiempo de espera mxima cerca del objetivo, transcurrido este tiempo  las patrullas se moveran a otro punto
KRON_UPS_maxwaiting = 60;

// how long AI units should be in alert mode after initially spotting an enemy
//Tiempo que las unidades permanecen alerta
KRON_UPS_alerttime = 90;

// how far opfors should move away if they're under attack
// Distancia de seguridad, se usa para calcular la distancia de flanqueo al objetivo
KRON_UPS_safedist = 300;

// how close unit has to be to target to generate a new one target or to enter stealth mode
// Se usa para determinar cuando es suficientemente cerca del objetivo, influye en la actitud de la IA
KRON_UPS_closeenough = 300;

// how close units have to be to each other to share information, over this, will lose target
//Distancia a la que tiene que estar el grupo de un enemigo conocido para que se les comunique la posicin del enemigo.
//Fuera de este radio la IA puede perder el rastro
//Las patrullas con rol "MOVE" tendrn un 1.5 de este valor
KRON_UPS_sharedist = 600;

//If enabled IA comunicating between them with radio defined sharedist distance, 
//1 check if visible friends in range (sharedist) are injured,  //Detecta cuando han herido a un compaero, menos ptimo
//2 check if enemy position is in range to atackt (sharedist) //Simula la comunicacion por radio entre la IA
KRON_UPS_comradio = 2;

//Habilita el envio de refuerzos cuando el enemigo es detectado, lo normal es que est siempre a false
// y se use un trigger para activar/desactivar esta opccin
KRON_UPS_reinforcement = false; 

//Establece los bandos de enemigos que debe considerar la IAs de la resistencia
KRON_UPS_Res_enemy = [east];

//Tiempo en segundos que tarda en volver a ejecutarse
KRON_UPS_Cycle = 20;

//Height that heli will fly this input will be randomiced in a 10%
KRON_UPS_flyInHeight = 100;

//Max distance to target for doing paradrop, will be randomiced between 0 and 100% of this value.
KRON_UPS_paradropdist = 250;

//Enables or disables AI to use static weapons
KRON_UPS_useStatics = true;

//Enables or disables AI to put mines if armored enemies near
KRON_UPS_useMines = true;

//Distance from destination for seraching vehicles
KRON_UPS_searchVehicledist = 500;

//Percentage for surrender in each side
KRON_UPS_EAST_SURRENDER = 0;
KRON_UPS_WEST_SURRENDER = 0;
KRON_UPS_GUER_SURRENDER = 0;

//Efective distance for doing perfect ambush (max distance is this x2)
KRON_UPS_ambushdist = 50;


//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
//		Initialization of public Variables used in script, do not touch	
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	KRON_UPS_flankAngle = 45; //Angulo de flanqueo
	KRON_UPS_INIT = 0;        //Variable que indica que ha sido inicializado
	KRON_UPS_EAST_SURRENDED = false;
	KRON_UPS_WEST_SURRENDED = false;
	KRON_UPS_GUER_SURRENDED = false;
	KRON_AllTroops=[];
	KRON_AllWest=[];	//All west AI 
	KRON_AllEast=[];	//All east AI 
	KRON_AllRes=[];		//All resistance AI 
	KRON_UPS_East_enemies = [];
	KRON_UPS_West_enemies = [];
	KRON_UPS_Guer_enemies = [];
	KRON_UPS_East_friends = [];
	KRON_UPS_West_friends = [];
	KRON_UPS_Guer_friends = [];
	KRON_targets0 =[];//objetivos west
	KRON_targets1 =[];//objetivos east
	KRON_targets2 =[];//resistence	
	KRON_targetsPos =[];//Posiciones de destino actuales.
	KRON_NPCs = []; //Lideres de los grupos actuales	
	KRON_UPS_Instances=0;
	KRON_UPS_Total=0;
	KRON_UPS_Exited=0;
	KRON_UPS_East_Total = 0;
	KRON_UPS_West_Total = 0;
	KRON_UPS_Guer_Total = 0;	
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

// ***************************************** SERVER INITIALIZATION *****************************************
if (isNil("KRON_UPS_INIT") || KRON_UPS_INIT == 0) then {

	//Init library function, Required Version: 5.0 of mon_functions
	call compile preprocessFileLineNumbers "upsmon\common\MON_functions.sqf";
	UPSMON = compile preprocessFile "upsmon\UPSMON.sqf";


	// declaracin de variables privadas
	private["_obj","_trg","_l","_pos"];

	// global functions
	KRON_randomPos = {private["_cx","_cy","_rx","_ry","_cd","_sd","_ad","_tx","_ty","_xout","_yout"];_cx=_this select 0; _cy=_this select 1; _rx=_this select 2; _ry=_this select 3; _cd=_this select 4; _sd=_this select 5; _ad=_this select 6; _tx=random (_rx*2)-_rx; _ty=random (_ry*2)-_ry; _xout=if (_ad!=0) then {_cx+ (_cd*_tx - _sd*_ty)} else {_cx+_tx}; _yout=if (_ad!=0) then {_cy+ (_sd*_tx + _cd*_ty)} else {_cy+_ty}; [_xout,_yout]};
	KRON_PosInfo = {private["_pos","_lst","_bld","_bldpos"];_pos=_this select 0; _lst=_pos nearObjects ["House",12]; if (count _lst==0) then {_bld=0;_bldpos=0} else {_bld=_lst select 0; _bldpos=[_bld] call KRON_BldPos}; [_bld,_bldpos]};
	KRON_PosInfo3 = {private["_pos","_lst","_bld","_bldpos"];_pos=_this select 0; _lst= nearestObjects [_pos, [], 3];
		if (count _lst==0) then {_bld=objnull;_bldpos=0} else {_bld = nearestbuilding (_lst select 0); 
		_bldpos=[_bld] call KRON_BldPos2}; [_bld,_bldpos]};
	KRON_BldPos = {private ["_bld","_bldpos","_posZ","_maxZ"];_bld=_this select 0;_maxZ=0;_bi=0;_bldpos=0;while {_bi>=0} do {if (((_bld BuildingPos _bi) select 0)==0) then {_bi=-99} else {_bz=((_bld BuildingPos _bi) select 2); if (((_bz)>4) && ((_bz>_maxZ) || ((_bz==_maxZ) && (random 1>.8)))) then {_maxZ=_bz; _bldpos=_bi}};_bi=_bi+1};_bldpos};
	KRON_BldPos2 = {private ["_bld","_bldpos"];
						_bld=_this select 0; _bldpos = 1;
						while {format ["%1", _bld buildingPos _bldpos] != "[0,0,0]"}  do {_bldpos = _bldpos + 1;};
					_bldpos = _bldpos - 1; _bldpos;};
	KRON_OnRoad = {private["_p","_w","_i","_lst"];_p=_this select 0; _w=_this select 1; _i=_this select 2; _lst=_p nearObjects ["House",12]; if ((count _lst==0) && (_w || !(surfaceIsWater _p))) then {_i=99}; (_i+1)};
	KRON_getDirPos = {private["_a","_b","_from","_to","_return"]; _from = _this select 0; _to = _this select 1; _return = 0; _a = ((_to select 0) - (_from select 0)); _b = ((_to select 1) - (_from select 1)); if (_a != 0 || _b != 0) then {_return = _a atan2 _b}; if ( _return < 0 ) then { _return = _return + 360 }; _return};
	KRON_distancePosSqr = {((((_this select 0) select 0)-((_this select 1) select 0))^2 + (((_this select 0) select 1)-((_this select 1) select 1))^2)^0.5};
	KRON_relPos = {private["_p","_d","_a","_x","_y","_xout","_yout"];_p=_this select 0; _x=_p select 0; _y=_p select 1; _d=_this select 1; _a=_this select 2; _xout=_x + sin(_a)*_d; _yout=_y + cos(_a)*_d;[_xout,_yout,0]};
	KRON_rotpoint = {private["_cp","_a","_tx","_ty","_cd","_sd","_cx","_cy","_xout","_yout"];_cp=_this select 0; _cx=_cp select 0; _cy=_cp select 1; _a=_this select 1; _cd=cos(_a*-1); _sd=sin(_a*-1); _tx=_this select 2; _ty=_this select 3; _xout=if (_a!=0) then {_cx+ (_cd*_tx - _sd*_ty)} else {_cx+_tx}; _yout=if (_a!=0) then {_cy+ (_sd*_tx + _cd*_ty)} else {_cy+_ty}; [_xout,_yout,0]};
	KRON_stayInside = {
		private["_np","_nx","_ny","_cp","_cx","_cy","_rx","_ry","_d","_tp","_tx","_ty","_fx","_fy"];
		_np=_this select 0;	_nx=_np select 0;	_ny=_np select 1;
		_cp=_this select 1;	_cx=_cp select 0;	_cy=_cp select 1;
		_rx=_this select 2;	_ry=_this select 3;	_d=_this select 4;
		_tp = [_cp,_d,(_nx-_cx),(_ny-_cy)] call KRON_rotpoint;
		_tx = _tp select 0; _fx=_tx;
		_ty = _tp select 1; _fy=_ty;
		if (_tx<(_cx-_rx)) then {_fx=_cx-_rx};
		if (_tx>(_cx+_rx)) then {_fx=_cx+_rx};
		if (_ty<(_cy-_ry)) then {_fy=_cy-_ry};
		if (_ty>(_cy+_ry)) then {_fy=_cy+_ry};
		if ((_fx!=_tx) || (_fy!=_ty)) then {_np = [_cp,_d*-1,(_fx-_cx),(_fy-_cy)] call KRON_rotpoint};
		_np;
	};
// Misc
	KRON_UPSgetArg = {private["_cmd","_arg","_list","_a","_v"]; _cmd=_this select 0; _arg=_this select 1; _list=_this select 2; _a=-1; {_a=_a+1; _v=format["%1",_list select _a]; if (_v==_cmd) then {_arg=(_list select _a+1)}} foreach _list; _arg};
	KRON_deleteDead = {private["_u","_s"];_u=_this select 0; _s= _this select 1; _u removeAllEventHandlers "killed"; sleep _s; deletevehicle _u};

	
// ***********************************************************************************************************	
//									  MAIN UPSMON SERVER FUNCTION 
// ***********************************************************************************************************	
	MON_MAIN_server = {
	
		private["_obj","_trg","_l","_pos","_countWestSur","_countEastSur","_countResSur","_WestSur","_EastSur","_ResSur","_targets","_targets0","_targets1","_targets2","_npc","_cycle"];
		_cycle = 10;

		_WestSur = KRON_UPS_WEST_SURRENDED;
		_EastSur = KRON_UPS_EAST_SURRENDED;
		_ResSur = KRON_UPS_GUER_SURRENDED;	
			
		//Main loop
		while {true} do 
		{			
			_countWestSur = round ( KRON_UPS_West_Total * KRON_UPS_WEST_SURRENDER / 100);
			_countEastSur = round ( KRON_UPS_East_Total * KRON_UPS_EAST_SURRENDER / 100);
			_countResSur = round ( KRON_UPS_Guer_Total * KRON_UPS_GUER_SURRENDER / 100);	
			
			//Checks for WEST surrender
			if (KRON_UPS_WEST_SURRENDER > 0 && !KRON_UPS_WEST_SURRENDED ) then {							
				{
					if (!alive _x || !canmove _x) then {KRON_AllWest = KRON_AllWest-[_x]};
				}foreach KRON_AllWest;
//				sleep .05;
				
				if ( count KRON_AllWest <= _countWestSur  ) then { 
					KRON_UPS_WEST_SURRENDED = true; 
					publicvariable "KRON_AllWest";					
					publicvariable "KRON_UPS_WEST_SURRENDED";
				};
			};				
			
			//Checks for EAST surrender
			if (KRON_UPS_EAST_SURRENDER > 0 && !KRON_UPS_EAST_SURRENDED ) then {							
				{
					if (!alive _x || !canmove _x) then {KRON_AllEast = KRON_AllEast-[_x]};
				}foreach KRON_AllEast;
//				sleep .05;
				
				if ( count KRON_AllEast <= _countEastSur  ) then { 
					KRON_UPS_EAST_SURRENDED = true; 
					publicvariable "KRON_AllEast";						
					publicvariable "KRON_UPS_EAST_SURRENDED";					
				};
			};				

			//Checks for RESISTANCE surrender
			if (KRON_UPS_GUER_SURRENDER > 0 && !KRON_UPS_GUER_SURRENDED ) then {							
				{
					if (!alive _x || !canmove _x) then {KRON_AllRes = KRON_AllRes-[_x]};
				}foreach KRON_AllRes;
//				sleep .05;
				
				if ( count KRON_AllRes <= _countResSur  ) then { 
					KRON_UPS_GUER_SURRENDED = true; 
					publicvariable "KRON_AllRes";						
					publicvariable "KRON_UPS_GUER_SURRENDED";						
				};			
			};	

			//Exec surrended script
			if (KRON_UPS_WEST_SURRENDED && !_WestSur ) then {
				_WestSur = true;
				nul=[west] execvm "upsmon\surrended.sqf";
			};
			if (KRON_UPS_EAST_SURRENDED && !_EastSur ) then {
				_EastSur = true;
				nul=[east] execvm "upsmon\surrended.sqf";
			};
			if (KRON_UPS_GUER_SURRENDED && !_ResSur ) then {
				_ResSur = true;
				nul=[Resistance] execvm "upsmon\surrended.sqf";
			};			
			sleep .5;
			
			//KRON_UPS_East_targets	
			
			_targets0 = [];
			_targets1 = [];
			_targets2 = [];
			{
				if (!isnull _x && alive _x && canmove _x && !captive _x ) then {	
					_npc = _x;
					_targets = [];
					
					//Gets known targets on each leader for comunicating enemy position
					_targets = _npc nearTargets KRON_UPS_sharedist;		
					
					{
						_soldier = _x select 4;
						if (!isnull _soldier && alive _soldier && canmove _soldier && !captive _soldier && _npc knowsabout _soldier > 0.5 
							//&& ( vehicle(_soldier)==_soldier || ((alive (gunner (vehicle _soldier)) && canmove (gunner (vehicle _soldier))) 
							//							   || (alive (driver (vehicle _soldier)) && canmove (driver (vehicle _soldier)))))
							&& ( "LandVehicle" countType [_x] == 0 || ( "LandVehicle" countType [_soldier] > 0 && 
																			(( alive (gunner _soldier) && canmove (gunner _soldier)) 
																				|| (alive (driver _soldier) && canmove (driver _soldier)))))
							&&  ("StaticWeapon" countType [_soldier] == 0 || ("StaticWeapon" countType [_soldier] >0 && (_soldier) emptyPositions "Gunner" == 0 ))
						) then {
											
							//Saves last known position
							_soldier setvariable ["UPSMON_lastknownpos", _x select 0, false];							
							
							//West targets
							if (side _npc == west && (side _soldier == east || (side _soldier == resistance && west in KRON_UPS_Res_enemy))) then {		
								_targets0 = _targets0 - [_soldier];		
								_targets0 = _targets0 + [_soldier];																		
							};	
							//East targets
							if (side _npc == east && (side _soldier == west || (side _soldier == resistance && east in KRON_UPS_Res_enemy))) then {						
								_targets1 = _targets1 - [_soldier];	
								_targets1 = _targets1 + [_soldier];		
							};	
							//Resistance targets
							if (side _npc == resistance && side _soldier in KRON_UPS_Res_enemy) then {																		
								_targets2 = _targets2 - [_soldier];
								_targets2 = _targets2 + [_soldier];	
							};	
						};	
					}foreach _targets;					
				};									
			}foreach KRON_NPCs;						
			
			//Sets shared targets
			KRON_targets0 = _targets0;	
			KRON_targets1 = _targets1;	
			KRON_targets2 = _targets2;							

			if (KRON_UPS_Debug>0) then {hintsilent parseText format["<t color='#33CC00'>West(A=%1 C=%2 T=%3)</t><br/><t color='#FF0000'>East(A=%4 C=%5 T=%6)</t><br/><t color='#00CCFF'>Res(A=%7 C=%8 T=%9)</t><br/>"
				,KRON_UPS_West_Total, count KRON_AllWest,count KRON_targets0,KRON_UPS_East_Total, count KRON_AllEast,count KRON_targets1,KRON_UPS_Guer_Total, count KRON_AllRes,count KRON_targets2]}; 
			//if (KRON_UPS_Debug>0) then {player globalchat format["W(A=%1 C=%2 T=%3) E(A=%4 C=%5 T=%6) R(A=%7 C=%8 T=%9)",KRON_UPS_West_Total, count KRON_AllWest,count KRON_targets0,
			//	KRON_UPS_East_Total, count KRON_AllEast,count KRON_targets1,KRON_UPS_Guer_Total, count KRON_AllRes,count KRON_targets2]}; 
			
			sleep _cycle;			
		};
	};	
	
	
	
// ***********************************************************************************************************	
//									  INITIALIZATION  OF UPSMON
// ***********************************************************************************************************		
	_obj = _this select 0;		
	_pos = [5000,5000];
	if (typename _obj=="OBJECT") then {_pos=position _obj};
	_trg=createTrigger ["EmptyDetector", _pos]; 
	_trg setTriggerArea [20000,20000,0,false]; 
	_trg setTriggerActivation ["ANY","PRESENT",false]; 
	_trg setTriggerTimeout [1,1,1,false];
	sleep 1 + (random 1);
	_l=[];
	_l=list _trg; 
	deleteVehicle _trg; 
	{
		if (("AllVehicles" countType [_x]>0) && (side _x != civilian)) then {
			KRON_AllTroops=KRON_AllTroops+[_x];
			_s = side _x;
			switch (_s) do {
				case west: 
					{ KRON_AllWest=KRON_AllWest+[_x]; };
				case east: 
					{ KRON_AllEast=KRON_AllEast+[_x]; };
				case resistance: 
					{ KRON_AllRes=KRON_AllRes+[_x]; };
			};
		};
		//sleep .05;
	} forEach _l;
	_l = nil;

	if (isNil("KRON_UPS_Debug")) then {KRON_UPS_Debug=0};
	//KRON_HQ="Logic" createVehicle [0,0];

	KRON_UPS_East_enemies = KRON_AllWest;
	KRON_UPS_West_enemies = KRON_AllEast;
	
	if (east in KRON_UPS_Res_enemy ) then {	
		KRON_UPS_East_enemies = KRON_UPS_East_enemies+KRON_AllRes;
		KRON_UPS_Guer_enemies = KRON_AllEast;
	} else {
		KRON_UPS_East_friends = KRON_UPS_East_friends+KRON_AllRes;
		KRON_UPS_Guer_friends = KRON_AllEast;
	}; 
		
	if (west in KRON_UPS_Res_enemy ) then {
		KRON_UPS_West_enemies = KRON_UPS_West_enemies+KRON_AllRes;
		KRON_UPS_Guer_enemies = KRON_UPS_Guer_enemies+KRON_AllWest;
	} else {
		KRON_UPS_West_friends = KRON_UPS_West_friends+KRON_AllRes;
		KRON_UPS_Guer_friends = KRON_UPS_Guer_friends+KRON_AllWest;
	};

	KRON_UPS_West_Total = count KRON_AllWest;		
	KRON_UPS_East_Total = count KRON_AllEast;
	KRON_UPS_Guer_Total = count KRON_AllRes;		
	
	//Initialization done
	KRON_UPS_INIT=1;	
};

// ---------------------------------------------------------------------------------------------------------

processInitCommands;

//Executes de main process of server
[] SPAWN MON_MAIN_server;

diag_log "--------------------------------";
diag_log (format["UPSMON started"]);
if(true) exitWith {}; 